﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;
using System.Reflection;
using $safeprojectname$.Model;
using System.Windows.Media.Imaging;

namespace $safeprojectname$.About
{
    public partial class About : PhoneApplicationPage
    {
        public About()
        {
            InitializeComponent();
            var nameHelper = new AssemblyName(Assembly.GetExecutingAssembly().FullName);
            this.RealApplicationVersion.Text = nameHelper.Version.Major + "." + nameHelper.Version.Minor + "." + nameHelper.Version.Build;
        }

       protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            UserSettings.Instance.SettingsChanged += appSettings_SettingsChanged;
            appSettings_SettingsChanged(UserSettings.Instance, EventArgs.Empty);
        }

        protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedFrom(e);
            UserSettings.Instance.SettingsChanged -= appSettings_SettingsChanged;
        }

        void appSettings_SettingsChanged(object sender, EventArgs e)
        {
            // This method gets called when any app settings change
            IntegerSettingText.Text = UserSettings.Instance.SettingInteger.ToString();
        }

        private void HomepageButton_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            // TODO - put in homepage URL here
            new WebBrowserTask { Uri = new Uri("http://example.com") }.Show();
        }

        private void MailButton_Click(object sender, RoutedEventArgs e)
        {
            // TODO - fill in To and Subject
            new EmailComposeTask { To = "", Subject = "$projectname$ Support" }.Show();
        }

        private void ReviewButton_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            new MarketplaceReviewTask().Show();
        }


        private void TrialUpgrade_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            new MarketplaceDetailTask().Show();
        }

        // Coerce the slider's value to an integer.
        private void IntegerSetting_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            ((Slider)sender).Value = Math.Round(e.NewValue);
        }

    }
}
